//
// 2D-texture bombing
//

uniform	sampler2D	randomMap;
uniform sampler2D	decalMap;
uniform sampler2D	glyphMap;

void main (void)
{
	const	float	scale = 1.0;

											// get decal color
	vec4	decalColor = texture2D ( decalMap, gl_TexCoord [0].xy * 0.25 );

											// get cell no based on texture coordinates
	vec2	tex     = gl_TexCoord [0].xy * scale;
	vec2	cell    = floor ( tex );
	vec2	offs    = tex - cell;
	int		i, j;

	for ( i = -1; i <= 0; i++ )
		for ( j = -1; j <= 0; j++ )
		{
			vec2	curCell = cell + vec2 ( i, j );
			vec2	curOffs = offs - vec2 ( i, j );
			vec2	rndOffs = curCell * vec2 ( 0.037, 0.119 );
			vec3	rnd     = texture2D ( randomMap, rndOffs ).rgb;
			vec2	t       = curOffs.xy - rnd.xy;
			
			decalColor += texture2D ( glyphMap, t );
		}

	gl_FragColor = decalColor;
}
