//
// 2D-texture bombing
//

uniform	sampler2D	randomMap;
uniform sampler2D	decalMap;
uniform sampler2D	glyphMap;

#define	SAMPLES_PER_CELL	3

void main (void)
{
	const	float	scale = 1.0;

											// get diffuse color
	vec4	decalColor = texture2D ( decalMap, gl_TexCoord [0].xy * 0.25 );

											// get cell no based on texture coordinates
	vec2	tex     = gl_TexCoord [0].xy * scale;
	vec2	cell    = floor ( tex );
	vec2	offs    = tex - cell;
	int		i, j, sample;

	for ( i = -1; i <= 0; i++ )
		for ( j = -1; j <= 0; j++ )
		{
			vec2	curCell = cell + vec2 ( i, j );
			vec2	curOffs = offs - vec2 ( i, j );
			vec2	rndOffs = curCell * vec2 ( 0.037, 0.119 );
			
			for ( sample = 0; sample < SAMPLES_PER_CELL; sample++ )
			{	
				vec3	rnd     = texture2D ( randomMap, rndOffs ).rgb;

				rndOffs    += vec2 ( 0.3123123, 0.431247 );
				decalColor += texture2D ( glyphMap, curOffs.xy - rnd.xy );
			}
		}
	
	gl_FragColor = decalColor;
}
