//
// 3D-texture bombing
//

varying	vec4	vertex;

uniform	sampler2D	randomMap;
uniform sampler2D	decalMap;
uniform sampler2D	glyphMap;

void main (void)
{
	const	float	scale     = 0.8;
											// get diffuse color
	vec4	decalColor = texture2D ( decalMap, gl_TexCoord [0].xy );


											// get cell no based on 3D-coordinates
	vec3	tex      = vertex.xyz * scale;
	vec3	cell     = floor ( tex );
	vec3	offs     = tex - cell;
	vec3	rndOffs  = cell / scale;
	vec4	colorSum = vec4 ( 0.0 );

	for ( int i = 0; i < 7; i++ )
	{
		vec2	rndTex = rndOffs.xy + 0.1* rndOffs.zx + 0.3*rndOffs.yz;
		vec3	rnd    = texture2D ( randomMap, rndTex ).rgb;
		vec3	center = vec3 ( 0.2 ) + 0.6 * rnd;
		float	radius = 0.2 * fract ( 0.6 * rndOffs.x );

		if ( length ( center - offs ) < radius )					// place a bomb
			decalColor = vec4 ( rnd, 1.0 );

		rndOffs += vec3 ( 0.345, 0.386, 0.773 );
	}

	gl_FragColor   = decalColor;
	gl_FragColor.a = 1.0;
}
